viGroupManager = {};
viGroupManager.groupTyp = { onLoad={},max=500,freeNumbers={},maxReached=false,xmlLoaded=false,onLoadGroupsVehicles=true };
viGroupManager.profil = {select="",groupSelect=1,save=true,autoSave=true};
source(VehicleInspector.modDir.."extension/viGroupManagerXml.lua");

viGroupManager.maxGroups = 10; --view limit 20
function viGroupManager:resetGroups()	
	viGroupManager.groups = {};
	viGroupManager.groupsName = {};
	viGroupManager.viewGroups = {};
	viGroupManager.groupProfile = {["Default"]=true};	
	for group=0, viGroupManager.maxGroups do --0 for marked Vehicles
		viGroupManager.groups[group] = {};
		viGroupManager.viewGroups[group] = group == 0;
		viGroupManager.groupsName[group] = "Group ".. tostring(group);
	end;
	viGroupManager.groupTyp.onLoad = {};
end;
viGroupManager:resetGroups();

function viGroupManager:setDefaultTypNumbers()
	for a=1, viGroupManager.groupTyp.max do
		viGroupManager.groupTyp.freeNumbers[a] = true;
	end;
end;
viGroupManager:setDefaultTypNumbers();

function viGroupManager:getFreeTypNumber()	
	for a=1, viGroupManager.groupTyp.max do
		if viGroupManager.groupTyp.freeNumbers[a] then return a;end;		
	end;
	viGroupManager.groupTyp.maxReached = true;
	return 0;	
end;

function viGroupManager:getActiveProfil()
	for profil, active in pairs(viGroupManager.groupProfile) do
		if active then return profil;end;
	end;
	return "Default";
end;

function viGroupManager:setActiveProfil()
	viGroupManager.groupProfile[viGroupManager:getActiveProfil()] = false;
	viGroupManager.groupProfile[viGroupManager.profil.select] = true;
	local copyProfile = g_currentMission.hl.getTableCopy(viGroupManager.groupProfile);	
	viGroupManager:resetGroups();
	viGroupManager.groupProfile = copyProfile;
	viGroupManager:deleteGroupsVehicles();	
	viGroupManagerXml:loadConfig(viGroupManager.profil.select);	
	viGroupManager.profil.save = false;
	---viGroupManagerXml:saveProfile();
	g_currentMission.hl.addTextDisplay( {txt="GroupManager: Load Group Profil... (".. tostring(viGroupManager.profil.select).. ".xml)", txtBold=true, duration=3} );
end;

function viGroupManager:hasGroupVehicles(group)
	for groupTyp, _ in pairs(viGroupManager.groups[group]) do
		if groupTyp ~= nil then return true;end;
	end;
	return false;
end;

function viGroupManager:isViewGroups(all)
	local viewGroups = {};
	for group=1, viGroupManager.groupTyp.max do
		if all ~= nil and all then
			if viGroupManager.viewGroups[group] then table.insert(viewGroups, group);end;
		else
			if viGroupManager.viewGroups[group] then return true;end;
		end;
	end;
	if all ~= nil and all then return viewGroups;end;
	return false;
end;

function viGroupManager:isViewGroup(group)	
	return viGroupManager.viewGroups[group];	
end;

function viGroupManager:setViewGroup(group)	
	viGroupManager.viewGroups[group] = not viGroupManager.viewGroups[group];	
end;

function viGroupManager:isVehicleGroup(vehicle, isMarked) --simple old
	if vehicle == nil or vehicle.viControl == nil or vehicle.viControl.group == nil then return false;end;
	for group, _ in pairs(vehicle.viControl.group) do
		if group > 0 then
			if vehicle.viControl.group[group] ~= nil then return true;end;		
		end;
	end;		
	return false;
end;

function viGroupManager:viewIsVehicleGroup(vehicle, isMarked)	
	if vehicle == nil or vehicle.viControl == nil or vehicle.viControl.group == nil then return false, false;end;
	local isGroup, viewGroup = false,false;	
	for group, _ in pairs(vehicle.viControl.group) do
		if group > 0 then
			if vehicle.viControl.group[group] ~= nil then isGroup = true;end;		
			viewGroup = viGroupManager:isViewGroup(group);
			if isGroup and viewGroup then break;end; 
		end;
	end;
	return isGroup, viewGroup;
end;

-----------------------------------------------

function viGroupManager:setVehicleGroup(vehicle, groupNumber)
	if vehicle == nil or vehicle.viControl == nil or vehicle.viControl.groupTyp == nil then return;end;
	if groupNumber ~= nil then vehicle.viControl.group[groupNumber] = true;end;
end;

function viGroupManager:delVehicleGroup(vehicle, groupNumber)
	if vehicle == nil or vehicle.viControl == nil or vehicle.viControl.groupTyp == nil then return;end;
	if groupNumber ~= nil and vehicle.viControl.group[groupNumber] ~= nil then vehicle.viControl.group[groupNumber] = nil;end;
end;

function viGroupManager:deleteGroupVehicle(vehicle, groupNumber, onDelete)
	if vehicle == nil or vehicle.viControl == nil then return;end;
	local groupTyp = vehicle.viControl.groupTyp;
	if viGroupManager.groupTyp.freeNumbers[groupTyp] ~= nil then
		if groupNumber == nil then
			for group=0, viGroupManager.maxGroups do
				--for groupTyp, _ in pairs(viGroupManager.groups[group]) do
				--	viGroupManager.groups[group][groupTyp] = nil;
				--	if onDelete == nil or not onDelete then viGroupManager:delVehicleGroup(vehicle, group);end;
				--end;
				if viGroupManager.groups[group][groupTyp] ~= nil then
					viGroupManager.groups[group][groupTyp] = nil;
					if onDelete == nil or not onDelete then viGroupManager:delVehicleGroup(vehicle, group);end;
				end;
			end;			
		elseif viGroupManager.groups[groupNumber] ~= nil and viGroupManager.groups[groupNumber][groupTyp] ~= nil then
			viGroupManager.groups[groupNumber][groupTyp] = nil;
			if onDelete == nil or not onDelete then viGroupManager:delVehicleGroup(vehicle, groupNumber);end;
		end;
		viGroupManager.profil.save = false;
	end;
end;

function viGroupManager:insertGroupVehicle(vehicle, groupNumber, info)
	if vehicle == nil or vehicle.viControl == nil then return;end;
	local groupTyp = vehicle.viControl.groupTyp;
	if viGroupManager.groupTyp.freeNumbers[groupTyp] ~= nil then
		if viGroupManager.groups[groupNumber] ~= nil then
			if viGroupManager.groups[groupNumber][groupTyp] == nil or (viGroupManager.groups[groupNumber][groupTyp] ~= nil and viGroupManager.groups[groupNumber][groupTyp].node == -1) then
				viGroupManager.groups[groupNumber][groupTyp] = {node=Utils.getNoNil(vehicle.rootNode, 0), name=tostring(vehicle.getName(vehicle))};				
				viGroupManager:setVehicleGroup(vehicle, groupNumber);
				if info ~= nil and info then
					local moreTxt = "Save a Group Profil with MouseClick Right on G"
					g_currentMission.hl.addTextDisplay( {txt="Insert Vehicle in Group "..tostring(groupNumber).. " (".. tostring(viGroupManager.groupsName[groupNumber]).. ")\n".. tostring(moreTxt), txtColor="green", maxLine=2, txtBold=true, duration=4} );
				end;
			else
				viGroupManager:deleteGroupVehicle(vehicle, groupNumber);
				if info ~= nil and info then
					local moreTxt = "Save a Group Profil with MouseClick Right on G";
					g_currentMission.hl.addTextDisplay( {txt="Delete Vehicle in Group "..tostring(groupNumber).. " (".. tostring(viGroupManager.groupsName[groupNumber]).. ")\n".. tostring(moreTxt), txtColor="orangeRed", maxLine=2, txtBold=true, duration=4} );
				end;
			end;
		end;
		viGroupManager.profil.save = false;
	end;
end;

function viGroupManager:insertGroupsVehicles() --set all Vehicles rootNode at groups and Vehicle groups
	if g_currentMission ~= nil and g_currentMission.vehicles ~= nil then
		print(tostring(VehicleInspector.metadata.title).. " *GroupManager* set Vehicles rootNodes and belonging groups")
		for v=1, #g_currentMission.vehicles do		
			local vehicle = g_currentMission.vehicles[v];			
			if vehicle ~= nil and vehicle.finishedLoading == true and vehicle.viControl ~= nil and vehicle.viControl.groupTyp ~= nil and vehicle.viControl.groupTyp > 0 then
				if viGroupManager.groupTyp.onLoad[vehicle.viControl.groupTyp] ~= nil and viGroupManager.groupTyp.onLoad[vehicle.viControl.groupTyp].group ~= nil then
					local insert = false;
					local vehicleName = tostring(vehicle.getName(vehicle));
					for _, groupNumber in pairs(viGroupManager.groupTyp.onLoad[vehicle.viControl.groupTyp].group) do
						if insert or vehicleName == tostring(viGroupManager.groupTyp.onLoad[vehicle.viControl.groupTyp].name) or tostring(viGroupManager.groupTyp.onLoad[vehicle.viControl.groupTyp].name) == "unknown" then
							viGroupManager.groups[groupNumber][vehicle.viControl.groupTyp] = {node=Utils.getNoNil(vehicle.rootNode, 0), name=vehicleName};
							vehicle.viControl.group[groupNumber] = true;
							if groupNumber == 0 then vehicle.viIsMarked = true;end;
							insert = true;							
							--print("###Set Group ".. tostring(groupNumber).. " at Vehicle - Vehiclename: ".. tostring(vehicleName).. " - GroupTyp: ".. tostring(vehicle.viControl.groupTyp))
						else
							--print("###Ghost Vehicle in Group ".. tostring(groupNumber).. " - Vehiclename: ".. tostring(vehicleName).. " and Savename: ".. tostring(viGroupManager.groupTyp.onLoad[vehicle.viControl.groupTyp].name).. " not identical - GroupTyp: ".. tostring(vehicle.viControl.groupTyp))
							break;
						end;
					end;
					if insert then viGroupManager.groupTyp.onLoad[vehicle.viControl.groupTyp] = nil;end;
				end;
			end;			
		end;
		--delete ghost vehicles--		
		for groupTyp, _ in pairs(viGroupManager.groupTyp.onLoad) do			
			if groupTyp ~= nil then
				for group=0, viGroupManager.maxGroups do
					for groupTyp, _ in pairs(viGroupManager.groups[group]) do
						if viGroupManager.groupTyp.onLoad[groupTyp] ~= nil then
							viGroupManager.groups[group][groupTyp] = nil;
						end;
					end;
				end;
				break;
			end;			
		end;
		viGroupManager.groupTyp.onLoad = {};		
		--delete ghost vehicles--
		viGroupManager.groupTyp.onLoadGroupsVehicles = false;
		viGroupManager.profil.save = true;
	end;		
end;

function viGroupManager:deleteGroupsVehicles()
	if g_currentMission ~= nil and g_currentMission.vehicles ~= nil then
		print(tostring(VehicleInspector.metadata.title).. " *GroupManager* refresh Vehicles rootNodes and belonging groups")
		for v=1, #g_currentMission.vehicles do		
			local vehicle = g_currentMission.vehicles[v];
			if vehicle ~= nil and vehicle.viControl ~= nil and vehicle.viControl.groupTyp ~= nil and  vehicle.viControl.groupTyp > 0 then
				vehicle.viIsMarked = false;
				vehicle.viControl.group = {};
			end;
		end;
		viGroupManager.groupTyp.onLoadGroupsVehicles = true;
	end;
end;
----------------------------------------
function viGroupManager:generateNewGroupProfil(name)
	local text = g_i18n:getText("ui_farmNew");	
	local confirmText = "Generate New Group Profil XML:";	
	g_gui:showTextInputDialog({
		text = text,		
		callback = function (result, yes)
			if yes then
				if result:len() < 4 or result:len() > 30 then
					result = nil;
					g_currentMission.hl.addTextDisplay( {txt="Characters min 4/max 30", txtBold=true, duration=3, warning=true} );					
				else
					viGroupManagerXml:generateNewGroupProfil(tostring(result), true);										
				end
			end
		end,
		dialogPrompt = g_i18n:getText("ui_enterName").. "\n(min length 4/max length 30)",
		imePrompt = g_i18n:getText("ui_enterName"),
		confirmText = confirmText,
		maxCharacters = 30,
		disableFilter = true
		--activateInputText = activateInputText,
		--args = args
	})
end;

function viGroupManager:editGroupName(group)
	local text = tostring(viGroupManager.groupsName[viGroupManager.profil.groupSelect]);	
	local confirmText = "Edit Group Name:";	
	g_gui:showTextInputDialog({
		text = text,		
		defaultText = text,
		callback = function (result, yes)
			if yes then
				if result:len() < 4 or result:len() > 30 then
					result = nil;
					g_currentMission.hl.addTextDisplay( {txt="Characters min 4/max 30", txtBold=true, duration=3, warning=true} );					
				else
					viGroupManagerXml:editGroupName(tostring(result), true);										
				end
			end
		end,
		dialogPrompt = g_i18n:getText("ui_enterName").. "\n(min length 4/max length 30)",
		imePrompt = g_i18n:getText("ui_enterName"),
		confirmText = confirmText,
		maxCharacters = 30,
		disableFilter = true
		--activateInputText = activateInputText,
		--args = args
	})
end;

----------------------------------------
function viGroupManager:printGroup(groupNumber)	--on test function
	if viGroupManager.groups[groupNumber] ~= nil then
		local groupEmpty = true;
		for groupTyp, value in pairs(viGroupManager.groups[groupNumber]) do			
			if value ~= nil and value.node ~= nil and value.node > 0 then
				local vehicle = g_currentMission.nodeToObject[value.node];
				if vehicle ~= nil then
					local name = tostring(vehicle.getName(vehicle))
					print("Vehicle ".. tostring(viGroupManager.groupsName[groupNumber]).. " - Vehiclename: ".. tostring(name).. " - GroupTyp: ".. tostring(groupTyp))
				end;
				groupEmpty = false;
			else
				print("Vehicle ".. tostring(viGroupManager.groupsName[groupNumber]).. " - Vehiclename: not found (Ghost) - GroupTyp: ".. tostring(groupTyp))
			end;			
		end;
		if groupEmpty then print("Vehicle ".. tostring(viGroupManager.groupsName[groupNumber]).. " is empty");end;	
	else
		print("Vehicle Group ".. tostring(groupNumber).. " not found")
	end;	
end;

function viGroupManager:printVehicleGroups(vehicle)	--on test function
	local vehicle = vehicle;
	if vehicle == nil and g_currentMission.controlledVehicle ~= nil then
		vehicle = g_currentMission.controlledVehicle;
	end;
	if vehicle ~= nil and vehicle.viControl ~= nil and vehicle.viControl.groupTyp ~= nil then
		local foundGroups = false;
		local name = tostring(vehicle.getName(vehicle));
		print("Vehiclename: ".. tostring(name))
		for group, _ in pairs(vehicle.viControl.group) do
			print("... is Group: ".. tostring(group))
			foundGroup = true;
		end;
		if not foundGroup then
			print("... is not in Groups !")
		end;
	end;		
end;